using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HySoft.DBUtility;
using System.Data.SqlClient;
using System.Data;

namespace HySoft.BaseCallCenter.DAL
{
    /// <summary>
    /// 数据访问类:T_Ask_PagerItems
    /// </summary>
    public partial class T_Ask_PagerItems
    {
        public T_Ask_PagerItems()
        { }
        #region  Method
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ItemId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Ask_PagerItems");
            strSql.Append(" where F_ItemId=@F_ItemId");
            SqlParameter[] parameters = {
					new SqlParameter("@F_ItemId", SqlDbType.Int,4)
			};
            parameters[0].Value = F_ItemId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(HySoft.BaseCallCenter.Model.T_Ask_PagerItems model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Ask_PagerItems(");
            strSql.Append("F_PagerId,F_QuestionId,F_Remark,F_Sort,F_Score)");
            strSql.Append(" values (");
            strSql.Append("@F_PagerId,@F_QuestionId,@F_Remark,@F_Sort,@F_Score)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
					new SqlParameter("@F_PagerId", SqlDbType.Int,4),
					new SqlParameter("@F_QuestionId", SqlDbType.Int,4),
					new SqlParameter("@F_Remark", SqlDbType.VarChar,200),
					new SqlParameter("@F_Sort", SqlDbType.Int,4),
					new SqlParameter("@F_Score", SqlDbType.Int,4)};
            parameters[0].Value = model.F_PagerId;
            parameters[1].Value = model.F_QuestionId;
            parameters[2].Value = model.F_Remark;
            parameters[3].Value = model.F_Sort;
            parameters[4].Value = model.F_Score;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(HySoft.BaseCallCenter.Model.T_Ask_PagerItems model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Ask_PagerItems set ");
            strSql.Append("F_PagerId=@F_PagerId,");
            strSql.Append("F_QuestionId=@F_QuestionId,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_Sort=@F_Sort,");
            strSql.Append("F_Score=@F_Score");
            strSql.Append(" where F_ItemId=@F_ItemId");
            SqlParameter[] parameters = {
					new SqlParameter("@F_PagerId", SqlDbType.Int,4),
					new SqlParameter("@F_QuestionId", SqlDbType.Int,4),
					new SqlParameter("@F_Remark", SqlDbType.VarChar,200),
					new SqlParameter("@F_Sort", SqlDbType.Int,4),
					new SqlParameter("@F_Score", SqlDbType.Int,4),
					new SqlParameter("@F_ItemId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_PagerId;
            parameters[1].Value = model.F_QuestionId;
            parameters[2].Value = model.F_Remark;
            parameters[3].Value = model.F_Sort;
            parameters[4].Value = model.F_Score;
            parameters[5].Value = model.F_ItemId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ItemId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Ask_PagerItems ");
            strSql.Append(" where F_ItemId=@F_ItemId");
            SqlParameter[] parameters = {
					new SqlParameter("@F_ItemId", SqlDbType.Int,4)
			};
            parameters[0].Value = F_ItemId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool DeleteByPagerId(int F_PagerId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Ask_PagerItems ");
            strSql.Append(" where F_PagerId=@F_PagerId");
            SqlParameter[] parameters = {
					new SqlParameter("@F_PagerId", SqlDbType.Int,4)
			};
            parameters[0].Value = F_PagerId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_ItemIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Ask_PagerItems ");
            strSql.Append(" where F_ItemId in (" + F_ItemIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public HySoft.BaseCallCenter.Model.T_Ask_PagerItems GetModel(int F_ItemId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ItemId,F_PagerId,F_QuestionId,F_Remark,F_Sort,F_Score from T_Ask_PagerItems ");
            strSql.Append(" where F_ItemId=@F_ItemId");
            SqlParameter[] parameters = {
					new SqlParameter("@F_ItemId", SqlDbType.Int,4)
			};
            parameters[0].Value = F_ItemId;

            HySoft.BaseCallCenter.Model.T_Ask_PagerItems model = new HySoft.BaseCallCenter.Model.T_Ask_PagerItems();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                if (ds.Tables[0].Rows[0]["F_ItemId"] != null && ds.Tables[0].Rows[0]["F_ItemId"].ToString() != "")
                {
                    model.F_ItemId = int.Parse(ds.Tables[0].Rows[0]["F_ItemId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_PagerId"] != null && ds.Tables[0].Rows[0]["F_PagerId"].ToString() != "")
                {
                    model.F_PagerId = int.Parse(ds.Tables[0].Rows[0]["F_PagerId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_QuestionId"] != null && ds.Tables[0].Rows[0]["F_QuestionId"].ToString() != "")
                {
                    model.F_QuestionId = int.Parse(ds.Tables[0].Rows[0]["F_QuestionId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_Remark"] != null && ds.Tables[0].Rows[0]["F_Remark"].ToString() != "")
                {
                    model.F_Remark = ds.Tables[0].Rows[0]["F_Remark"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_Sort"] != null && ds.Tables[0].Rows[0]["F_Sort"].ToString() != "")
                {
                    model.F_Sort = int.Parse(ds.Tables[0].Rows[0]["F_Sort"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_Score"] != null && ds.Tables[0].Rows[0]["F_Score"].ToString() != "")
                {
                    model.F_Score = int.Parse(ds.Tables[0].Rows[0]["F_Score"].ToString());
                }
                return model;
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ItemId,F_PagerId,F_QuestionId,F_Remark,F_Sort,F_Score ");
            strSql.Append(" FROM T_Ask_PagerItems ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ItemId,F_PagerId,F_QuestionId,F_Remark,F_Sort,F_Score ");
            strSql.Append(" FROM T_Ask_PagerItems ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Ask_PagerItems ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ItemId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Ask_PagerItems T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetList(int PageSize,int PageIndex,string strWhere)
        {
            SqlParameter[] parameters = {
                    new SqlParameter("@tblName", SqlDbType.VarChar, 255),
                    new SqlParameter("@fldName", SqlDbType.VarChar, 255),
                    new SqlParameter("@PageSize", SqlDbType.Int),
                    new SqlParameter("@PageIndex", SqlDbType.Int),
                    new SqlParameter("@IsReCount", SqlDbType.Bit),
                    new SqlParameter("@OrderType", SqlDbType.Bit),
                    new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
                    };
            parameters[0].Value = "T_Ask_PagerItems";
            parameters[1].Value = "F_ItemId";
            parameters[2].Value = PageSize;
            parameters[3].Value = PageIndex;
            parameters[4].Value = 0;
            parameters[5].Value = 0;
            parameters[6].Value = strWhere;	
            return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
        }*/

        #endregion  Method
    }
}


